'Script by Florian Rossmark
'Version 1.0

Const SQLConnection = "Provider=SQLOLEDB.1;Server=servername\instanace;Database=ITPrinterManagement;Trusted_Connection=Yes;"

Dim WSHShell
Set WSHShell = CreateObject("WScript.Shell")

Dim con, rs, rs2
Set con = CreateObject("ADODB.Connection")
Set rs = CreateObject("ADODB.Recordset")
Set rs2 = CreateObject("ADODB.Recordset")

Dim objWMI
Set objWMI = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2") 

Dim bolNetwork 'Boolean - used in a bit version

Dim UserID, ComputerID, PrinterID, LogNotes

con.Open SQLConnection
	rs.Open "SELECT TOP 1 * FROM tblPrinterMgmtUsers WHERE UserName LIKE '" & TRIM(WSHShell.ExpandEnvironmentStrings("%UserName%")) & "'", con, 2, 2
		If rs.EOF Then
			rs.AddNew
				rs("UserName") = TRIM(WSHShell.ExpandEnvironmentStrings("%UserName%"))
			rs.Update
			rs.Requery
		End If
		UserID = rs("ID")
	rs.Close
	rs.Open "SELECT TOP 1 * FROM tblPrinterMgmtComputer WHERE ComputerName LIKE '" & TRIM(WSHShell.ExpandEnvironmentStrings("%ComputerName%")) & "'", con, 2, 2
		If rs.EOF Then
			rs.AddNew
				rs("ComputerName") = TRIM(WSHShell.ExpandEnvironmentStrings("%ComputerName%"))
			rs.Update
			rs.Requery
		End If
		ComputerID = rs("ID")
	rs.Close	
	
	Set colPrinters = objWMI.ExecQuery("Select * from Win32_Printer")
	For Each objPrinter in colPrinters
		If Not Len(objPrinter.PortName) = 5 And Not Left(objPrinter.PortName,2) = "TS" Then
			LogNotes = ""
			If objPrinter.Network Then bolNetwork = 1 Else bolNetwork = 0
			rs.Open "SELECT TOP 1 * FROM tblPrinterMgmtPrinter WHERE NetworkPrinter = " & bolNetwork & " AND PrinterNamePath LIKE '" & TRIM(objPrinter.DeviceID) & "'", con, 2, 2
				If rs.EOF Then
					rs.AddNew
						rs("NetworkPrinter") = bolNetwork
						rs("PrinterNamePath") = TRIM(objPrinter.DeviceID)
					rs.Update
					rs.Requery
				Else 'printer exists - there might be a status replace or delete
					If objPrinter.Network Then
						If rs("ControlStatusID") = 2 Then 'delete
							LogNotes = "printer delete attempted"
							'delete
							PrinterDelete objPrinter
						ElseIf rs("ControlStatusID") = 3 Then 'replace
							LogNotes = "printer replace attempted with"
							If rs("ReplaceWithID") > 0 Then
								rs2.Open "SELECT TOP 1 * FROM tblPrinterMgmtPrinter WHERE ID = " & rs("ReplaceWithID"), con, 2, 2
									If Not rs2.EOF Then
										If rs2("ControlStatusID") = 1 Then
											LogNotes = LogNotes & "'" & rs2("PrinterNamePath") & "'"
											'delete
											PrinterDelete objPrinter
											'connect
											PrinterConnect rs2("PrinterNamePath")
										Else
											LogNotes = LogNotes & " - replace printer status is remove or delete - deleting this printer as fallback method"
											'delete
											PrinterDelete objPrinter
										End If
									End If
								rs2.Close
							Else
								LogNotes = LogNotes & " - no replace printer defined"
							End If
						End If
					Else
						'local printer
						'we do nothing - a user normally shouldn't have admin-rights to execute any actions here
					End If
				End If
				PrinterID = rs("ID")
			rs.Close
			rs.Open "SELECT TOP 1 * FROM tblPrinterMgmtUserComputerPrinterLog WHERE UserID = " & UserID & " AND ComputerID = " & ComputerID & " AND PrinterID = " & PrinterID, con, 2, 2
				If rs.EOF Then
					rs.AddNew
						rs("UserID") = UserID
						rs("ComputerID") = ComputerID
						rs("PrinterID") = PrinterID
				End If
				If Len(Trim(LogNotes)) > 0 Then rs("LogNotes") = LogNotes
				rs("LogDateTime") = Now()
				rs.Update
			rs.Close
		End If
	Next
	
con.Close

Set objWMI = Nothing

Set rs2 = Nothing
Set rs = Nothing
Set con = Nothing

Set WSHShell = Nothing

Sub PrinterDelete(objPrinter) 
	If objPrinter.Network Then
		Set objNetwork = CreateObject("WScript.Network") 
			objNetwork.RemovePrinterConnection objPrinter.DeviceID
		Set objNetwork = Nothing
	End If
End Sub

Sub PrinterConnect(UNCPath)
	Set objNetwork = CreateObject("WScript.Network") 
		objNetwork.AddWindowsPrinterConnection UNCPath
	Set objNetwork = Nothing
End Sub